﻿' -----------------------------------------------------------------------------------------
'
' Rob91FR.vb                                                        Ulrich Müller  02.04.08
'                                                                   PCS1700 VB 2005 Express
' Demo Robot aus Profi Computing 1991 : Lösung mit FishRobot
'      Die Ansteuerung der Motoren erfolgt teilweise simultan. die Simultanität kann
'      durch einfaches weglassen von Methoden-Aufrufen zu Lasten der Griffsicherheit
'      gesteigert werden.
'      Achtung : M1 (I1 = Ende, I2 = Impuls), M2 (I3, I4), M3 ( I5, I6)
'                Die Drehrichtung der Motoren wurde umgekehrt
'      Basis ist die Assembly FishFace2005.DLL
'
' -----------------------------------------------------------------------------------------

Option Explicit On
Option Strict Off
Imports FishFace40

Public Class Rob91FR

  Const mDreh = Out.M1
  Dim DrehPos1 As Integer
  Dim DrehPos2 As Integer
  Const mArm = Out.M2
  Const cArmOben = 0
  Dim ArmUnten As Integer
  Const mZange = Out.M3
  Const cZangeOffen = 0
  Dim ZangeZu As Integer

  Dim WithEvents ft As New FishRobot(New Integer(,) _
                                     {{mDreh, 222}, {mArm, 20}, {mZange, 30}})

  Sub ft_PositionChange(ByVal sender As Object, _
                        ByVal actPos As Integer()) Handles ft.PositionChange
    Dim Pos As String = "Position : "
    For i As Integer = 0 To actPos.Length - 2
      Pos += actPos(i) & " - "
    Next
    lblPosition.Text = Pos & actPos(actPos.Length - 1)
  End Sub

  
  Private Sub Action()
    ZangeZu = numZange.Value
    ArmUnten = numArm.Value
    DrehPos1 = numPos1.Value
    DrehPos2 = numPos2.Value
    lblStatus.Text = "Fährt auf Grundstellung"
    ft.MoveHome()
    Do
      lblStatus.Text = "Zu Position 1"
      ft.MoveTo(DrehPos1)
      ft.MoveTo(DrehPos1, ArmUnten)
      ft.MoveTo(DrehPos1, ArmUnten, ZangeZu)
      ft.MoveTo(DrehPos1, cArmOben)
      lblStatus.Text = "Zu Position 2"
      ft.MoveTo(DrehPos2)
      ft.MoveTo(DrehPos2, ArmUnten)
      ft.MoveTo(DrehPos2, ArmUnten, cZangeOffen)
      ft.MoveTo(DrehPos2, cArmOben)
    Loop Until ft.Finish()
  End Sub

#Region "--- ProgramControl ---"
  Private Sub cmdAction_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) _
  Handles cmdAction.Click
    ' --- Open erste ROBO Interface an USB oder Intelligent Interface an COM ---
    '     während des Ablaufs von Action gesperrt
    Try
      If cboPortName.SelectedIndex = 0 Then
        ft.OpenInterface(IFTypen.ftROBO_first_USB, 0)
      Else
        ft.OpenInterface(IFTypen.ftIntelligent_IF, cboPortName.SelectedIndex, 5)
      End If
      cmdAction.Enabled = False
      cmdEnde.Text = "&HALT"
      lblStatus.Text = "--- Bei der Arbeit ---"

      Action()          ' --- Nutz-Routine für die Anwendung

      ft.ClearMotors()
    Catch ex As FishFaceException
      MsgBox(ex.Message)
    Finally
      ft.CloseInterface()
      cmdAction.Enabled = True
      cmdEnde.Text = "&ENDE"
      lblStatus.Text = "--- Auf ein Neues ---"
      cmdEnde.Focus()
    End Try

  End Sub

  Private Sub cmdEnde_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdEnde.Click
    ' --- Programmende nur, wenn Action nicht läuft ---
    If cmdEnde.Text = "&HALT" Then ft.NotHalt = True Else Me.Close()
  End Sub

  Private Sub ManBeispiele_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
    ' --- Default erstes ROBO Interface an USB ---
    cboPortName.SelectedIndex = 2
  End Sub

  Private Sub ManBeispiele_FormClosing(ByVal sender As System.Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles MyBase.FormClosing
    ' --- Wenn Action läuft, wird ein Programmabbruch über (x) unterbunden ---
    If cmdEnde.Text = "&HALT" Then e.Cancel = True
  End Sub

#End Region


End Class
